﻿using System;
using System.Diagnostics;
using System.Text;
using WawaSoft.HttpStack;

namespace Test {
    class Program {
        static void Main(string[] args)
        {
            string part1 = @"GET / HTTP/1.1
Accept: */*
Accept-Language: zh-cn
User-Agent: Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 5.1; Trident/4.0; .NET ";
            string part2 = @"CLR 2.0.50727; .NET CLR 3.0.04506.648; .NET CLR 3.5.21022; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)
Accept-Encoding: gzip, deflate
Host: www.baidu.com
Connection: Keep-Alive
Cookie: BAIDUID=EC2710B99D2C1271EE0B0F54DB6382B2:FG=1; BDSTAT=1896c874a8258fa73d6d55fbb2fb43166d224f4a3ba4462309f79052992211a0

HTTP/1.1 ";
            string part3 = @"200 OK
Date: Sun, 05 Apr 2009 00:29:16 GMT
Server: BWS/1.0
Content-Length: 150
Content-Type: text/html
Cache-Control: private
Expires: Sun, 05 Apr 2009 00:29:16 GMT
Content-Encoding: gzip

<html><head><meta http-equiv=Content-Type content=""text/html;charset=gb2312""><title>百度一下，你就知道</title</head>我是百度<body></body>";
            HttpParser parser = new HttpParser();
            parser.RequestReceived += parser_RequestReceived;
            parser.ResponseReceived += parser_ResponseReceived;
            parser.Error += parser_Error;
            CodeTimer.Initialize();
            CodeTimer.Time("name1", 1, delegate()
                                              {
                                                  TestCase(parser, part1, part2, part3);
                                              });
            Console.ReadKey();
        }



        private static void TestCase(HttpParser parser, string part1, string part2, string part3)
        {
            parser.Parse(Encoding.UTF8.GetBytes(part1));
            parser.Parse(Encoding.UTF8.GetBytes(part2));
            parser.Parse(Encoding.UTF8.GetBytes(part3));
        }

        static void parser_Error(Exception obj) {
            Console.WriteLine("parse error\r\n{0}",obj);
        }

        static void parser_ResponseReceived(HttpResponse obj) {
            Console.WriteLine("parse response\r\n{0}",obj);
        }

        static void parser_RequestReceived(HttpRequest obj) {
            Console.WriteLine("parse request\r\n{0}",obj);
        }
    }
}
