﻿using System.Collections.Generic;
using System;
using System.Text;

namespace WawaSoft.HttpStack {
    public class BytesNode{
        private readonly byte[] _bytes;
        public BytesNode Next;
        int _start;
        int _end;
        public BytesNode(byte[] bs) {
            _bytes = bs;
            _start = 0;
            _end = bs.Length;
        }
        private BytesNode(byte[] bs, int start, int end) {
            _bytes = bs;
            _start = start;
            _end = end;
        }
        public BytesNode CutNew(BytesNode preNode, int start, int end) {
            BytesNode tempNode = new BytesNode(_bytes, start, end);
            if(preNode != null)preNode.Next = tempNode;
            tempNode.Next = Next;
            return tempNode;
        }
        public void Cut(int start, int end) {
            _start = start;
            _end = end;
        }
        public int Start {
            get { return _start; }
        }
        public int End {
            get { return _end; }
        }
        public int Length {
            get { return _end - _start; }
        }
        public byte[] Value {
            get { return _bytes; }
        }

        public byte[] Bytes {
            get {
                List<byte> ret = new List<byte>();
                BytesNode tempNode = this;
                byte[] tempBs;
                while (tempNode != null) {
                    tempBs = new byte[tempNode.Length];
                    Buffer.BlockCopy(tempNode.Value, tempNode.Start, tempBs, 0, tempNode.Length);
                    ret.AddRange(tempBs);
                    tempNode = tempNode.Next;
                }
                return ret.ToArray();
            }
        }
        public string GetString()
        {
            return GetString(Encoding.UTF8);
        }
        public string GetString(Encoding encoding)
        {
            Decoder decoder = encoding.GetDecoder();
            StringBuilder sb = new StringBuilder();
            BytesNode tempNode = this;
            while (tempNode != null)
            {
                char[] chars = new char[decoder.GetCharCount(tempNode.Value, tempNode.Start, tempNode.Length)];
                decoder.GetChars(tempNode.Value, tempNode.Start,
                                 tempNode.Length, chars, 0);
                sb.Append(chars);
                tempNode = tempNode.Next;
            }
            return sb.ToString();
        }
    }
}