﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Net.Sockets;

namespace FxLib {
    class ClientSocket {
        private string _remoteIp;
        private int _remotePort;
        public ClientSocket(string endpoint) {
            string[] temp = endpoint.Split(':');
            if (temp.Length != 2) throw new ArgumentException("endpoint");
            _remoteIp = temp[0];
            _remotePort = int.Parse(temp[1]);
        }

        private NetworkStream _stream;
        public void Start() {
            TcpClient client = new TcpClient(_remoteIp, _remotePort);
            _stream = client.GetStream();
            byte[] buffer = new byte[1024];
            _stream.BeginRead(buffer, 0, 1024, _streamReadCallback, buffer);
        }
        void _streamReadCallback(IAsyncResult ar)
        {
             byte[] buffer = new byte[1024];
             _stream.BeginRead(buffer, 0, 1024, _streamReadCallback, buffer);
            int readCount = _stream.EndRead(ar);
            byte[] receiveBuffer = ar.AsyncState as byte[];
            byte[] data = new byte[readCount];
            Buffer.BlockCopy(buffer, 0, data, 0, readCount);
            Action<byte[]> temp = DataReceived;
            if (temp != null)
                temp(data);
        }

        public void Stop() {
        }

        public event Action<byte[]> DataReceived;

        public void Send(byte[] data) {
            _stream.Write(data, 0, data.Length);
        }
    }
}
